import os
os.environ.setdefault('DJANGO_SETTINGS_MODULE', 'grady.settings')

import random
import django
django.setup()


from django.contrib.auth.models import Group, User

from core.models import Feedback, Student, Submission, SubmissionType


blob1 = r""" # '\[gap\]([\w\W]+?)\[\/gap\]'
# '\[select\]([\w\W]+?)\[\/select\]'
# '\[numeric\]([\w\W]+?)\[\/numeric\]'
# We match against one big regex that consists of three smaller ones (see above)
_all = re.compile('(\[numeric\]([\w\W]+?)\[\/numeric\]|\[select\]([\w\W]+?)\[\/select\]|\[gap\]([\w\W]+?)\[\/gap\])', re.MULTILINE)
for m in re.finditer(_all, task):
    print(m.span())
 """
blob2 = r""" #include <stdio.h>
#include <stdlib.h>
#include <assert.h>

const char str[] = "Is it constant?";

int main(int argc, char const *argv[])
{
    printf("%s\n", str);

    char *p = (char *) str;

    p[2] = '9';

    printf("%s\n", str);
} """
blob3 = r""" public Linie() {
            System.out.println(":)");
        }
    }

    public static void main(String[] args) {
        int x;
        if (7 == 0) {
            return;
        } else {
            System.out.println(123);
        }

        Linie l = new Linie();
        l.x = 3;
        System.out.println("Bye." + l.x);
    }
} """
blob4 = r""" class Uhrzeit implements Comparable<Uhrzeit> {
    private int stunde; // Stundenangabe
    private int minute; // Minutenangabe
    public Uhrzeit(int stunde, int minute) { // nur sinnvolle Zeitangaben ..
        if ( 0 <= stunde && stunde <= 23 &&  // .. behandeln
                0 <= minute && minute <= 59) {
            this.stunde = stunde;   // Stundenangabe zuweisen
            this.minute = minute;   // Minutenangabe zuweisen
        } else throw new RuntimeException("Ungültige Zeitangabe!");
    }

    public String toString() { // String-Darstellung in der Form:
        return stunde + " Uhr und " + minute + " Minute(n)"; // <Stundenangabe> Uhr und <Minutenangabe> Minuten
    } """
blob5 = r"""  -rw-r--r--   1 doncamillo  staff   499B  1 Mar 15:08 lala.cc
35015309 -rwxr-xr-x   1 doncamillo  staff    60K  1 Mar 15:08 lala.o
34389884 drwxr-xr-x  34 doncamillo  staff   1.1K 17 Feb 09:50 lci/
18040235 -rw-r--r--   1 doncamillo  staff   3.0K 15 Jun  2016 mensabot.py
 9923840 -rw-r--r--   1 doncamillo  staff   192B 20 Mar  2015 minmax.py
35166931 drwxr-xr-x   4 doncamillo  staff   136B  2 Mar 16:53 mydockerbuild/
32581151 drwxr-xr-x  29 doncamillo  staff   986B 30 Dec 03:22 mypy/
32674577 -rw-r--r--   1 doncamillo  staff    56B  1 Jan 03:34 num.py
32674574 -rw-r--r--   1 doncamillo  staff   3.7K  1 Jan 03:34 num.txt
16672100 drwxr-xr-x   7 doncamillo  staff   238B  4 May  2016 ophase-shirt/
20108315 drwxr-xr-x   7 doncamillo  staff   238B 30 Jul  2016 orni/
30452432 -rw-r--r--   1 doncamillo  staff   1.6K  9 Dec 13:50 out.csv
32495350 -rw-r--r--   1 doncamillo  staff   962B 28 Dec 01:09 out.zip
 9923841 -rw-r--r--   1 doncamillo  staff    59B 15 Jul  2015 packing.py
18450212 -rw-r--r--   1 doncamillo  staff   5.4K 28 Jun  2016 punkte02.csv
29250808 drwxr-xr-x  20 doncamillo  staff   680B 14 Nov 17:16 python-weka-wrapper/
17702721 -rw-r--r--   1 doncamillo  staff   525B 23 Jun  2016 reverse.class
17702665 -rw-r--r--   1 doncamillo  staff   711B 23 Jun  2016 reverse.java
33930378 drwxr-xr-x   8 doncamillo  staff   272B  6 Feb 09:44 rust/
34209249 -rw-r--r--   1 doncamillo  staff   2.2K  6 Feb 09:44 rust.tar.gz
32494205 -rw-r--r--   1 doncamillo  staff   271B 28 Dec 00:56 scriptll.py
13587552 -rw-r--r--   1 doncamillo  staff   985B  9 Mar  2016 second.java
20108498 -rw-r-----@  1 doncamillo  staff   2.3K 30 Jul  2016 speech_api_key.json
32488712 -rw-r--r--   1 doncamillo  staff   160B 27 Dec 23:55 suppe.py
33496687 drwxr-xr-x   5 doncamillo  staff   170B 24 Jan 18:28 tcpi.py/
33446903 drwxr-xr-x   4 doncamillo  staff   136B 23 Jan 13:51 temp/
18772243 -rwxr-xr-x   1 doncamillo  staff   8.4K  5 Jul  2016 test
30907796 drwxr-xr-x   5 doncamillo  staff """


def populate():
    try:
        User.objects.create_superuser(
            username='doncamillo', password=input("Superuser password"), email='a@b.com')
    except Exception as e:
        print("- Superuser was already created.")

    add_group('Students')
    tutor_group = add_group('Tutors')
    reviewer_group = add_group('Reviewers')

    add_user('Test_Tutor', tutor_group)
    add_user('Test_Reviewer', reviewer_group)

    s1 = add_student('Test_Student1')
    s2 = add_student('Test_Student2')
    s3 = add_student('Test_Student3')

    sub_t1 = add_submission_type("Irgendwas Sortieren", 10)
    sub_t2 = add_submission_type("Irgendwas Mischen", 20)
    sub_t3 = add_submission_type("Irgendwas Hacken", 30)

    add_submission(sub_t1, blob1, s1)
    add_submission(sub_t2, blob2, s1)
    add_submission(sub_t3, blob3, s2)
    add_submission(sub_t1, blob4, s2)
    add_submission(sub_t3, blob5, s3)


def add_submission_type(name, score):
    task = SubmissionType()
    task.name = name
    task.full_score = score
    task.task_description = "Das hat der Student zu sehen bekommen. (Aufgabenstellung)"
    task.possible_solution = "So könnte das mal aussehen"
    task.correction_guideline = "So solltest du das korrigiert werden"
    task.save()
    print(f"- Created Task {task.name}")
    return task


def add_submission(type, text, student, pre="Vorgabe"):
    sub = Submission()
    sub.type = type
    sub.text = text
    sub.pre_corrections = pre
    sub.student = student
    sub.save()
    print(f"- Created Submission of Type {sub.type}")
    return sub


def add_student(name):
    student_group = Group.objects.get(name='Students')
    student_user = add_user(name, student_group)
    student = Student(
        user=student_user, matrikel_no=20000000 + random.randrange(21343))
    student.save()
    return student


def add_user(username, group, password='password'):
    user, _ = User.objects.get_or_create(username=username)
    user.set_password(password)
    group.user_set.add(user)
    print(f"- Created user {user} and added him to group {group}")
    user.save()
    return user


def add_group(group_name):
    group, _ = Group.objects.get_or_create(name=group_name)
    group.save()
    print(f"- Created group {group}")
    return group

# Start execution here!
if __name__ == '__main__':
    print("Starting population script...")
    populate()
